diff --git a/gplugin/gplugin-manager.c b/gplugin/gplugin-manager.c
--- a/gplugin/gplugin-manager.c
+++ b/gplugin/gplugin-manager.c
@@ -773,914 +1223,9 @@
 	return plugins_list;
 }
 
-static GSList *
-gplugin_manager_real_find_plugins_with_state(
-	GPluginManager *manager,
-	GPluginPluginState state)
-{
-	GPluginManagerPrivate *priv = NULL;
-	GSList *plugins = NULL;
-	GHashTableIter iter;
-	gpointer value = NULL;
-
-	priv = gplugin_manager_get_instance_private(manager);
-
-	g_hash_table_iter_init(&iter, priv->plugins);
-	while(g_hash_table_iter_next(&iter, NULL, &value)) {
-		GSList *l = NULL;
-
-		for(l = (GSList *)value; l != NULL; l = l->next) {
-			GPluginPlugin *plugin = GPLUGIN_PLUGIN(l->data);
-
-			if(gplugin_plugin_get_state(plugin) == state) {
-				plugins =
-					g_slist_prepend(plugins, g_object_ref(G_OBJECT(plugin)));
-			}
-		}
-	}
-
-	return plugins;
-}
-
-static GList *
-gplugin_manager_real_list_plugins(GPluginManager *manager)
-{
-	GPluginManagerPrivate *priv = NULL;
-	GQueue *queue = g_queue_new();
-	GList *ret = NULL;
-	GHashTableIter iter;
-	gpointer key = NULL;
-
-	priv = gplugin_manager_get_instance_private(manager);
-
-	g_hash_table_iter_init(&iter, priv->plugins);
-	while(g_hash_table_iter_next(&iter, &key, NULL)) {
-		g_queue_push_tail(queue, (gchar *)key);
-	}
-
-	ret = g_list_copy(queue->head);
-
-	g_queue_free(queue);
-
-	return ret;
-}
-
-static gboolean
-gplugin_manager_load_dependencies(
-	GPluginPlugin *plugin,
-	GPluginPluginInfo *info,
-	GError **error)
-{
-	GSList *dependencies = NULL, *l = NULL;
-	GError *ourerror = NULL;
-	gboolean all_loaded = TRUE;
-
-	dependencies = gplugin_manager_get_plugin_dependencies(plugin, &ourerror);
-	if(ourerror != NULL) {
-		g_propagate_error(error, ourerror);
-
-		return FALSE;
-	}
-
-	for(l = dependencies; l != NULL; l = l->next) {
-		GPluginPlugin *dependency = GPLUGIN_PLUGIN(l->data);
-		gboolean loaded = FALSE;
-
-		loaded = gplugin_manager_load_plugin(dependency, &ourerror);
-
-		if(!loaded || ourerror != NULL) {
-			if(ourerror != NULL) {
-				g_propagate_error(error, ourerror);
-			}
-
-			all_loaded = FALSE;
-			break;
-		}
-	}
-
-	g_slist_free_full(dependencies, g_object_unref);
-
-	return all_loaded;
-}
-
-static GSList *
-gplugin_manager_real_get_plugin_dependencies(
-	G_GNUC_UNUSED GPluginManager *manager,
-	GPluginPlugin *plugin,
-	GError **error)
-{
-	GPluginPluginInfo *info = NULL;
-	GSList *ret = NULL;
-	const gchar *const *dependencies = NULL;
-	gint i = 0;
-
-	info = gplugin_plugin_get_info(plugin);
-	dependencies = gplugin_plugin_info_get_dependencies(info);
-	g_object_unref(G_OBJECT(info));
-
-	if(dependencies == NULL) {
-		return NULL;
-	}
-
-	for(i = 0; dependencies[i] != NULL; i++) {
-		gboolean found = FALSE;
-		gchar **ors = NULL;
-		gint o = 0;
-
-		ors = g_strsplit(dependencies[i], "|", 0);
-		for(o = 0; ors[o]; o++) {
-			GMatchInfo *match = NULL;
-			GSList *matches = NULL;
-			gchar *oid = NULL, *oop = NULL, *over = NULL;
-
-			if(!g_regex_match(dependency_regex, ors[o], 0, &match)) {
-				continue;
-			}
-
-			/* grab the or'd id, op, and version */
-			oid = g_match_info_fetch_named(match, "id");
-			oop = g_match_info_fetch_named(match, "op");
-			over = g_match_info_fetch_named(match, "version");
-
-			/* free the match info */
-			g_match_info_free(match);
-
-			/* now look for a plugin matching the id */
-			matches = gplugin_manager_find_plugins_with_version(oid, oop, over);
-			g_free(oid);
-			g_free(oop);
-			g_free(over);
-
-			if(matches == NULL) {
-				continue;
-			}
-
-			/* prepend the first found match to our return value */
-			ret = g_slist_prepend(ret, g_object_ref(matches->data));
-			g_slist_free_full(matches, g_object_unref);
-
-			found = TRUE;
-
-			break;
-		}
-		g_strfreev(ors);
-
-		if(!found) {
-			g_set_error(
-				error,
-				GPLUGIN_DOMAIN,
-				0,
-				_("failed to find dependency %s for %s"),
-				dependencies[i],
-				gplugin_plugin_info_get_id(info));
-
-			g_slist_free_full(ret, g_object_unref);
-
-			return NULL;
-		}
-	}
-
-	return ret;
-}
-
-static gboolean
-gplugin_manager_real_load_plugin(
-	GPluginManager *manager,
-	GPluginPlugin *plugin,
-	GError **ret_error)
-{
-	GPluginPluginInfo *info = NULL;
-	GPluginLoader *loader = NULL;
-	GError *error = NULL;
-	gboolean ret = TRUE;
-
-	g_return_val_if_fail(GPLUGIN_IS_PLUGIN(plugin), FALSE);
-
-	/* if the plugin is already loaded there's nothing for us to do */
-	if(gplugin_plugin_get_state(plugin) == GPLUGIN_PLUGIN_STATE_LOADED) {
-		return TRUE;
-	}
-
-	/* now try to get the plugin info from the plugin */
-	info = gplugin_plugin_get_info(plugin);
-	if(info == NULL) {
-		gchar *filename = gplugin_plugin_get_filename(plugin);
-
-		g_set_error(
-			ret_error,
-			GPLUGIN_DOMAIN,
-			0,
-			_("Plugin %s did not return value plugin info"),
-			filename);
-		g_free(filename);
-
-		gplugin_plugin_set_state(plugin, GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
-
-		return FALSE;
-	}
-
-	if(!gplugin_manager_load_dependencies(plugin, info, ret_error)) {
-		g_object_unref(G_OBJECT(info));
-
-		return FALSE;
-	}
-
-	g_object_unref(G_OBJECT(info));
-
-	/* now load the actual plugin */
-	loader = gplugin_plugin_get_loader(plugin);
-
-	if(!GPLUGIN_IS_LOADER(loader)) {
-		gchar *filename = gplugin_plugin_get_filename(plugin);
-
-		g_set_error(
-			ret_error,
-			GPLUGIN_DOMAIN,
-			0,
-			_("The loader for %s is not a loader.  This "
-			  "should not happened!"),
-			filename);
-		g_free(filename);
-
-		gplugin_plugin_set_state(plugin, GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
-
-		return FALSE;
-	}
-
-	g_signal_emit(manager, signals[SIG_LOADING], 0, plugin, &error, &ret);
-	if(!ret) {
-		/* Set the plugin's error. */
-		g_object_set(G_OBJECT(plugin), "error", error, NULL);
-
-		g_propagate_error(ret_error, error);
-
-		gplugin_plugin_set_state(plugin, GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
-
-		return ret;
-	}
-
-	ret = gplugin_loader_load_plugin(loader, plugin, &error);
-	if(ret) {
-		g_signal_emit(manager, signals[SIG_LOADED], 0, plugin);
-	} else {
-		g_signal_emit(manager, signals[SIG_LOAD_FAILED], 0, plugin);
-
-		g_propagate_error(ret_error, error);
-	}
-
-	return ret;
-}
-
-static gboolean
-gplugin_manager_real_unload_plugin(
-	GPluginManager *manager,
-	GPluginPlugin *plugin,
-	GError **ret_error)
-{
-	GPluginLoader *loader = NULL;
-	GError *error = NULL;
-	gboolean ret = TRUE;
-
-	g_return_val_if_fail(GPLUGIN_IS_PLUGIN(plugin), FALSE);
-
-	if(gplugin_plugin_get_state(plugin) != GPLUGIN_PLUGIN_STATE_LOADED) {
-		return TRUE;
-	}
-
-	loader = gplugin_plugin_get_loader(plugin);
-	if(!GPLUGIN_IS_LOADER(loader)) {
-		g_set_error_literal(
-			ret_error,
-			GPLUGIN_DOMAIN,
-			0,
-			_("Plugin loader is not a loader"));
-
-		return FALSE;
-	}
-
-	g_signal_emit(manager, signals[SIG_UNLOADING], 0, plugin, &error, &ret);
-	if(!ret) {
-		/* Set the plugin's error. */
-		g_object_set(G_OBJECT(plugin), "error", error, NULL);
-
-		g_propagate_error(ret_error, error);
-
-		gplugin_plugin_set_state(plugin, GPLUGIN_PLUGIN_STATE_LOAD_FAILED);
-
-		return ret;
-	}
-
-	ret = gplugin_loader_unload_plugin(loader, plugin, &error);
-	if(ret) {
-		g_signal_emit(manager, signals[SIG_UNLOADED], 0, plugin);
-	} else {
-		g_signal_emit(manager, signals[SIG_UNLOAD_FAILED], 0, plugin);
-
-		g_propagate_error(ret_error, error);
-	}
-
-	return ret;
-}
-
-static gboolean
-gplugin_manager_loading_cb(
-	G_GNUC_UNUSED GPluginManager *manager,
-	G_GNUC_UNUSED GPluginPlugin *plugin,
-	G_GNUC_UNUSED GError **error)
-{
-	return TRUE;
-}
-
-static gboolean
-gplugin_manager_unloading_cb(
-	G_GNUC_UNUSED GPluginManager *manager,
-	G_GNUC_UNUSED GPluginPlugin *plugin,
-	G_GNUC_UNUSED GError **error)
-{
-	return TRUE;
-}
-
-/******************************************************************************
- * GObject Implementation
- *****************************************************************************/
-static void
-gplugin_manager_finalize(GObject *obj)
-{
-	GPluginManager *manager = GPLUGIN_MANAGER(obj);
-	GPluginManagerPrivate *priv = gplugin_manager_get_instance_private(manager);
-
-	g_queue_free_full(priv->paths, g_free);
-	priv->paths = NULL;
-
-	/* unload all of the loaded plugins */
-	g_hash_table_foreach(
-		priv->plugins,
-		gplugin_manager_foreach_unload_plugin,
-		NULL);
-
-	/* free all the data in the plugins hash table and destroy it */
-	g_hash_table_foreach_remove(
-		priv->plugins,
-		gplugin_manager_remove_list_value,
-		NULL);
-	g_clear_pointer(&priv->plugins, g_hash_table_destroy);
-
-	/* destroy the filename view */
-	g_clear_pointer(&priv->plugins_filename_view, g_hash_table_destroy);
-
-	/* clean up our list of loaders */
-	g_slist_free_full(priv->loaders, g_object_unref);
-	priv->loaders = NULL;
-
-	/* free all the data in the loaders hash table and destroy it */
-	g_hash_table_foreach_remove(
-		priv->loaders_by_extension,
-		gplugin_manager_remove_list_value,
-		NULL);
-	g_clear_pointer(&priv->loaders_by_extension, g_hash_table_destroy);
-
-	/* call the base class's destructor */
-	G_OBJECT_CLASS(gplugin_manager_parent_class)->finalize(obj);
-}
-
-static void
-gplugin_manager_class_init(GPluginManagerClass *klass)
-{
-	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
-	GPluginManagerClass *manager_class = GPLUGIN_MANAGER_CLASS(klass);
-
-	obj_class->finalize = gplugin_manager_finalize;
-
-	manager_class->append_path = gplugin_manager_real_append_path;
-	manager_class->prepend_path = gplugin_manager_real_prepend_path;
-	manager_class->remove_path = gplugin_manager_real_remove_path;
-	manager_class->remove_paths = gplugin_manager_real_remove_paths;
-	manager_class->get_paths = gplugin_manager_real_get_paths;
-
-	manager_class->register_loader = gplugin_manager_real_register_loader;
-	manager_class->unregister_loader = gplugin_manager_real_unregister_loader;
-	manager_class->get_loaders = gplugin_manager_real_get_loaders;
-
-	manager_class->refresh = gplugin_manager_real_refresh;
-
-	manager_class->foreach = gplugin_manager_real_foreach;
-
-	manager_class->find_plugins = gplugin_manager_real_find_plugins;
-	manager_class->find_plugins_with_state =
-		gplugin_manager_real_find_plugins_with_state;
-	manager_class->list_plugins = gplugin_manager_real_list_plugins;
-
-	manager_class->get_plugin_dependencies =
-		gplugin_manager_real_get_plugin_dependencies;
-
-	manager_class->load_plugin = gplugin_manager_real_load_plugin;
-	manager_class->unload_plugin = gplugin_manager_real_unload_plugin;
-
-	manager_class->loading_plugin = gplugin_manager_loading_cb;
-	manager_class->unloading_plugin = gplugin_manager_unloading_cb;
-
-	/* signals */
-
-	/**
-	 * GPluginManager::loading-plugin:
-	 * @manager: The #GPluginManager instance.
-	 * @plugin: The #GPluginPlugin that's about to be loaded.
-	 * @error: Return address for a #GError.
-	 *
-	 * Emitted before @plugin is loaded.
-	 *
-	 * Return FALSE to stop loading
-	 */
-	signals[SIG_LOADING] = g_signal_new(
-		"loading-plugin",
-		G_OBJECT_CLASS_TYPE(manager_class),
-		G_SIGNAL_RUN_LAST,
-		G_STRUCT_OFFSET(GPluginManagerClass, loading_plugin),
-		gplugin_boolean_accumulator,
-		NULL,
-		NULL,
-		G_TYPE_BOOLEAN,
-		2,
-		G_TYPE_OBJECT,
-		G_TYPE_POINTER);
-
-	/**
-	 * GPluginManager::loaded-plugin:
-	 * @manager: the #gpluginpluginmanager instance.
-	 * @plugin: the #gpluginplugin that's about to be loaded.
-	 *
-	 * emitted after a plugin is loaded.
-	 */
-	signals[SIG_LOADED] = g_signal_new(
-		"loaded-plugin",
-		G_OBJECT_CLASS_TYPE(manager_class),
-		G_SIGNAL_RUN_LAST,
-		G_STRUCT_OFFSET(GPluginManagerClass, loaded_plugin),
-		NULL,
-		NULL,
-		NULL,
-		G_TYPE_NONE,
-		1,
-		G_TYPE_OBJECT);
-
-	/**
-	 * GPluginManager::load-plugin-failed:
-	 * @manager: The #GPluginManager instance.
-	 * @plugin: The #GPluginPlugin that failed to load.
-	 *
-	 * emitted after a plugin fails to load.
-	 */
-	signals[SIG_LOAD_FAILED] = g_signal_new(
-		"load-plugin-failed",
-		G_OBJECT_CLASS_TYPE(manager_class),
-		G_SIGNAL_RUN_LAST,
-		G_STRUCT_OFFSET(GPluginManagerClass, load_failed),
-		NULL,
-		NULL,
-		NULL,
-		G_TYPE_NONE,
-		1,
-		G_TYPE_OBJECT);
-
-	/**
-	 * GPluginManager::unloading-plugin
-	 * @manager: the #GPluginManager instance.
-	 * @plugin: the #GPluginPlugin that's about to be unloaded.
-	 * @error: Return address for a #GError.
-	 *
-	 * emitted before a plugin is unloaded.
-	 *
-	 * Return FALSE to stop unloading
-	 */
-	signals[SIG_UNLOADING] = g_signal_new(
-		"unloading-plugin",
-		G_OBJECT_CLASS_TYPE(manager_class),
-		G_SIGNAL_RUN_LAST,
-		G_STRUCT_OFFSET(GPluginManagerClass, unloading_plugin),
-		gplugin_boolean_accumulator,
-		NULL,
-		NULL,
-		G_TYPE_BOOLEAN,
-		2,
-		G_TYPE_OBJECT,
-		G_TYPE_POINTER);
-
-	/**
-	 * GPluginManager::unloaded-plugin:
-	 * @manager: the #gpluginpluginmanager instance.
-	 * @plugin: the #gpluginplugin that's about to be loaded.
-	 *
-	 * emitted after a plugin is successfully unloaded.
-	 */
-	signals[SIG_UNLOADED] = g_signal_new(
-		"unloaded-plugin",
-		G_OBJECT_CLASS_TYPE(manager_class),
-		G_SIGNAL_RUN_LAST,
-		G_STRUCT_OFFSET(GPluginManagerClass, unloaded_plugin),
-		NULL,
-		NULL,
-		NULL,
-		G_TYPE_NONE,
-		1,
-		G_TYPE_OBJECT);
-
-	/**
-	 * GPluginManager::unload-plugin-failed:
-	 * @manager: The #GPluginManager instance.
-	 * @plugin: The #GPluginPlugin instance that failed to unload.
-	 * @error: A #GError instance.
-	 *
-	 * Emitted when @manager was asked to unload @plugin, but @plugin returned
-	 * %FALSE when its unload function was called.
-	 */
-	signals[SIG_UNLOAD_FAILED] = g_signal_new(
-		"unload-plugin-failed",
-		G_OBJECT_CLASS_TYPE(manager_class),
-		G_SIGNAL_RUN_LAST,
-		G_STRUCT_OFFSET(GPluginManagerClass, unload_plugin_failed),
-		NULL,
-		NULL,
-		NULL,
-		G_TYPE_NONE,
-		1,
-		G_TYPE_OBJECT);
-}
-
-static void
-gplugin_manager_init(GPluginManager *manager)
-{
-	GPluginManagerPrivate *priv = gplugin_manager_get_instance_private(manager);
-
-	priv->paths = g_queue_new();
-
-	/* the plugins hashtable is keyed on a plugin id and holds a GSList of all
-	 * plugins that share that id.
-	 */
-	priv->plugins =
-		g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
-
-	/* the filename view is hash table keyed on the filename of the plugin with
-	 * a value of the plugin itself.
-	 */
-	priv->plugins_filename_view =
-		g_hash_table_new_full(g_str_hash, g_str_equal, g_free, g_object_unref);
-
-	/* The loaders_by_extension hash table is keyed on the supported extensions
-	 * of the loader.  Which means that a loader that supports multiple
-	 * extensions will be in the table multiple times.
-	 *
-	 * We deal with collisions by using a GSList for the value which will hold
-	 * references to instances of the actual loaders.
-	 *
-	 * Storing this in this method allows us to quickly figure out which loader
-	 * to use by the filename and helps us to avoid iterating the loaders table
-	 * again and again.
-	 */
-	priv->loaders_by_extension = g_hash_table_new_full(
-		gplugin_manager_str_hash,
-		g_str_equal,
-		g_free,
-		NULL);
-}
-
-/******************************************************************************
- * Private API
- *****************************************************************************/
-void
-gplugin_manager_private_init(gboolean register_native_loader)
-{
-	GError *error = NULL;
-
-	if(instance != NULL) {
-		return;
-	}
-
-	instance = g_object_new(GPLUGIN_TYPE_MANAGER, NULL);
-
-	if(register_native_loader) {
-		if(!gplugin_manager_register_loader(
-			   GPLUGIN_TYPE_NATIVE_LOADER,
-			   &error)) {
-			if(error != NULL) {
-				g_error("failed to register loader: %s", error->message);
-				g_error_free(error);
-			} else {
-				g_error("failed to register loader: unknown failure");
-			}
-		}
-	}
-
-	dependency_regex = g_regex_new(dependency_pattern, 0, 0, NULL);
-}
-
-void
-gplugin_manager_private_uninit(void)
-{
-	g_regex_unref(dependency_regex);
-
-	g_clear_object(&instance);
-}
-
-/******************************************************************************
- * API
- *****************************************************************************/
-
-/**
- * gplugin_manager_append_path:
- * @path: A path to add to the end of the plugin search paths.
- *
- * Adds @path to the end of the list of paths to search for plugins.
- */
-void
-gplugin_manager_append_path(const gchar *path)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_if_fail(GPLUGIN_IS_MANAGER(instance));
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->append_path) {
-		klass->append_path(instance, path);
-	}
-}
-
-/**
- * gplugin_manager_prepend_path:
- * @path: A path to add to the beginning of the plugin search paths.
- *
- * Adds @path to the beginning of the list of paths to search for plugins.
- */
-void
-gplugin_manager_prepend_path(const gchar *path)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_if_fail(GPLUGIN_IS_MANAGER(instance));
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->prepend_path) {
-		klass->prepend_path(instance, path);
-	}
-}
-
-/**
- * gplugin_manager_remove_path:
- * @path: A path to remove from the plugin search paths.
- *
- * Removes @path from the list of paths to search for plugins.
- */
-void
-gplugin_manager_remove_path(const gchar *path)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_if_fail(GPLUGIN_IS_MANAGER(instance));
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->remove_path) {
-		klass->remove_path(instance, path);
-	}
-}
-
-/**
- * gplugin_manager_remove_paths:
- *
- * Clears all paths that are set to search for plugins.
- */
-void
-gplugin_manager_remove_paths(void)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_if_fail(GPLUGIN_IS_MANAGER(instance));
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->remove_paths) {
-		klass->remove_paths(instance);
-	}
-}
-
-/**
- * gplugin_manager_add_default_paths:
- *
- * Adds the path that GPlugin was installed to to the plugin search path, as
- * well as `${XDG_CONFIG_HOME}/gplugin` so users can install additional loaders
- * themselves.
- */
-void
-gplugin_manager_add_default_paths(void)
-{
-	gchar *path;
-
-	path = g_build_filename(PREFIX, LIBDIR, "gplugin", NULL);
-	gplugin_manager_prepend_path(path);
-	g_free(path);
-
-	path = g_build_filename(g_get_user_config_dir(), "gplugin", NULL);
-	gplugin_manager_prepend_path(path);
-	g_free(path);
-}
-
-/**
- * gplugin_manager_add_app_paths:
- * @prefix: The installation prefix for the application.
- * @appname: The name of the application whose paths to add.
- *
- * Adds the application installation path for @appname.  This will add
- * `@prefix/@appname/plugins` to the list as well as
- * `${XDG_CONFIG_HOME}/@appname/plugins`.
- */
-void
-gplugin_manager_add_app_paths(const gchar *prefix, const gchar *appname)
-{
-	gchar *path;
-
-	g_return_if_fail(appname != NULL);
-
-	path = g_build_filename(prefix, LIBDIR, appname, NULL);
-	gplugin_manager_prepend_path(path);
-	g_free(path);
-
-	path = g_build_filename(g_get_user_config_dir(), appname, "plugins", NULL);
-	gplugin_manager_prepend_path(path);
-	g_free(path);
-}
-
-/**
- * gplugin_manager_get_paths:
- *
- * Gets the list of paths which will be searched for plugins.
- *
- * Returns: (element-type utf8) (transfer none): The list of paths which will
- *          be searched for plugins.
- */
-GList *
-gplugin_manager_get_paths(void)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), NULL);
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->get_paths) {
-		return klass->get_paths(instance);
-	}
-
-	return NULL;
-}
-
-/**
- * gplugin_manager_register_loader:
- * @type: #GType of a #GPluginLoader.
- * @error: (out) (nullable): The return address for a #GError.
- *
- * Registers @type as an available loader.
- *
- * Returns: %TRUE if the loader was successfully register, %FALSE otherwise
- *          with @error set.
- */
-gboolean
-gplugin_manager_register_loader(GType type, GError **error)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), FALSE);
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->register_loader) {
-		return klass->register_loader(instance, type, error);
-	}
-
-	g_set_error(
-		error,
-		GPLUGIN_DOMAIN,
-		0,
-		"register_loader method not implemented");
-
-	return FALSE;
-}
-
-/**
- * gplugin_manager_unregister_loader:
- * @type: #GType of a #GPluginLoader.
- * @error: (out) (nullable): The return address for a #GError.
- *
- * Unregisters @type as an available loader.
- *
- * Returns: %TRUE if the loader was successfully unregistered, %FALSE
- *          otherwise with @error set.
- */
-gboolean
-gplugin_manager_unregister_loader(GType type, GError **error)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), FALSE);
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->unregister_loader) {
-		return klass->unregister_loader(instance, type, error);
-	}
-
-	g_set_error(
-		error,
-		GPLUGIN_DOMAIN,
-		0,
-		"unregister_loader method not implemented");
-
-	return FALSE;
-}
-
-/**
- * gplugin_manager_get_loaders:
- *
- * Returns a list of all registered #GPluginLoader's.
- *
- * Returns: (element-type GPlugin.Loader) (transfer full): Returns a list of all
- *          registered loaders.
- */
-GSList *
-gplugin_manager_get_loaders(void)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), FALSE);
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->get_loaders) {
-		return klass->get_loaders(instance);
-	}
-
-	return NULL;
-}
-
-/**
- * gplugin_manager_refresh:
- *
- * Forces a refresh of all plugins found in the search paths.
- */
-void
-gplugin_manager_refresh(void)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_if_fail(GPLUGIN_IS_MANAGER(instance));
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->refresh) {
-		klass->refresh(instance);
-	}
-}
-
-/**
- * gplugin_manager_foreach:
- * @func: (scope call): The #GPluginManagerForeachFunc to call.
- * @data: User data to pass to func.
- *
- * Calls @func for each plugin that is known.
- */
-void
-gplugin_manager_foreach(GPluginManagerForeachFunc func, gpointer data)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_if_fail(GPLUGIN_IS_MANAGER(instance));
-	g_return_if_fail(func != NULL);
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->foreach) {
-		klass->foreach(instance, func, data);
-	}
-}
-
-/**
- * gplugin_manager_find_plugins:
- * @id: id string of the plugin to find.
- *
- * Finds all plugins matching @id.
- *
- * Returns: (element-type GPlugin.Plugin) (transfer full): A #GSList of
- *          referenced #GPluginPlugin's matching @id.  Call
- *          g_slist_free_full() with a `DestroyNotify` of g_object_unref() on
- *          the returned value when you're done with it.
- */
-GSList *
-gplugin_manager_find_plugins(const gchar *id)
-{
-	GPluginManagerClass *klass = NULL;
-
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), NULL);
-
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->find_plugins) {
-		return klass->find_plugins(instance, id);
-	}
-
-	return NULL;
-}
-
 /**
  * gplugin_manager_find_plugins_with_version:
+ * @manager: The #GPluginManager instance.
  * @id: The ID of the plugin to find.
  * @op: one of <, <=, =, ==, >=, >.
  * @version: The version to compare against.
@@ -1697,15 +1242,16 @@
  */
 GSList *
 gplugin_manager_find_plugins_with_version(
+	GPluginManager *manager,
 	const gchar *id,
 	const gchar *op,
 	const gchar *version)
 {
 	GSList *plugins = NULL, *filtered = NULL, *l = NULL;
 
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), NULL);
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), NULL);
 
-	plugins = gplugin_manager_find_plugins(id);
+	plugins = gplugin_manager_find_plugins(manager, id);
 
 	if((op == NULL || *op == '\0') && (version == NULL || *version == '\0')) {
 		/* we weren't actually passed an operator and a version so just return
@@ -1757,6 +1303,7 @@
 
 /**
  * gplugin_manager_find_plugins_with_state:
+ * @manager: The #GPluginManager instance.
  * @state: The #GPluginPluginState to look for.
  *
  * Finds all plugins that currently have a state of @state.
@@ -1767,22 +1314,39 @@
  *          the returned value when you're done with it.
  */
 GSList *
-gplugin_manager_find_plugins_with_state(GPluginPluginState state)
+gplugin_manager_find_plugins_with_state(
+	GPluginManager *manager,
+	GPluginPluginState state)
 {
-	GPluginManagerClass *klass = NULL;
+	GPluginManagerPrivate *priv = NULL;
+	GSList *plugins = NULL;
+	GHashTableIter iter;
+	gpointer value = NULL;
+
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), NULL);
+
+	priv = gplugin_manager_get_instance_private(manager);
 
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), NULL);
+	g_hash_table_iter_init(&iter, priv->plugins);
+	while(g_hash_table_iter_next(&iter, NULL, &value)) {
+		GSList *l = NULL;
 
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->find_plugins_with_state) {
-		return klass->find_plugins_with_state(instance, state);
+		for(l = (GSList *)value; l != NULL; l = l->next) {
+			GPluginPlugin *plugin = GPLUGIN_PLUGIN(l->data);
+
+			if(gplugin_plugin_get_state(plugin) == state) {
+				plugins =
+					g_slist_prepend(plugins, g_object_ref(G_OBJECT(plugin)));
+			}
+		}
 	}
 
-	return NULL;
+	return plugins;
 }
 
 /**
  * gplugin_manager_find_plugin:
+ * @manager: The #GPluginManager instance.
  * @id: The id of the plugin to find.
  *
  * Finds the first plugin matching @id.  This function uses
@@ -1793,14 +1357,14 @@
  *               if no plugin matching @id was found.
  */
 GPluginPlugin *
-gplugin_manager_find_plugin(const gchar *id)
+gplugin_manager_find_plugin(GPluginManager *manager, const gchar *id)
 {
 	GSList *plugins_list = NULL;
 	GPluginPlugin *plugin = NULL;
 
 	g_return_val_if_fail(id != NULL, NULL);
 
-	plugins_list = gplugin_manager_find_plugins(id);
+	plugins_list = gplugin_manager_find_plugins(manager, id);
 	if(plugins_list == NULL) {
 		return NULL;
 	}
@@ -1814,6 +1378,7 @@
 
 /**
  * gplugin_manager_find_plugin_with_newest_version:
+ * @manager: The #GPluginManager instance.
  * @id: The id of the plugin to find.
  *
  * Calls gplugin_manager_find_plugins() with @id, and then returns the plugins
@@ -1823,7 +1388,9 @@
  *          highest version number, or %NULL if no plugins were found with @id.
  */
 GPluginPlugin *
-gplugin_manager_find_plugin_with_newest_version(const gchar *id)
+gplugin_manager_find_plugin_with_newest_version(
+	GPluginManager *manager,
+	const gchar *id)
 {
 	GPluginPlugin *plugin_a = NULL;
 	GPluginPluginInfo *info_a = NULL;
@@ -1832,7 +1399,7 @@
 
 	g_return_val_if_fail(id != NULL, NULL);
 
-	l = gplugin_manager_find_plugins(id);
+	l = gplugin_manager_find_plugins(manager, id);
 	for(; l != NULL; l = g_slist_delete_link(l, l)) {
 		GPluginPlugin *plugin_b = NULL;
 		GPluginPluginInfo *info_b = NULL;
@@ -1886,6 +1453,7 @@
 
 /**
  * gplugin_manager_get_plugin_dependencies:
+ * @manager: The #GPluginManager instance.
  * @plugin: The #GPluginPlugin whose dependencies to get.
  * @error: (out) (nullable): Return address for a #GError.
  *
@@ -1898,24 +1466,95 @@
  *               you're done with it.
  */
 GSList *
-gplugin_manager_get_plugin_dependencies(GPluginPlugin *plugin, GError **error)
+gplugin_manager_get_plugin_dependencies(
+	GPluginManager *manager,
+	GPluginPlugin *plugin,
+	GError **error)
 {
-	GPluginManagerClass *klass = NULL;
+	GPluginPluginInfo *info = NULL;
+	GSList *ret = NULL;
+	const gchar *const *dependencies = NULL;
+	gint i = 0;
 
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), NULL);
 	g_return_val_if_fail(GPLUGIN_IS_PLUGIN(plugin), NULL);
 
-	g_return_val_if_fail(GPLUGIN_IS_MANAGER(instance), NULL);
+	info = gplugin_plugin_get_info(plugin);
+	dependencies = gplugin_plugin_info_get_dependencies(info);
+	g_object_unref(G_OBJECT(info));
 
-	klass = GPLUGIN_MANAGER_GET_CLASS(instance);
-	if(klass && klass->get_plugin_dependencies) {
-		return klass->get_plugin_dependencies(instance, plugin, error);
+	if(dependencies == NULL) {
+		return NULL;
 	}
 
-	return NULL;
+	for(i = 0; dependencies[i] != NULL; i++) {
+		gboolean found = FALSE;
+		gchar **ors = NULL;
+		gint o = 0;
+
+		ors = g_strsplit(dependencies[i], "|", 0);
+		for(o = 0; ors[o]; o++) {
+			GMatchInfo *match = NULL;
+			GSList *matches = NULL;
+			gchar *oid = NULL, *oop = NULL, *over = NULL;
+
+			if(!g_regex_match(dependency_regex, ors[o], 0, &match)) {
+				continue;
+			}
+
+			/* grab the or'd id, op, and version */
+			oid = g_match_info_fetch_named(match, "id");
+			oop = g_match_info_fetch_named(match, "op");
+			over = g_match_info_fetch_named(match, "version");
+
+			/* free the match info */
+			g_match_info_free(match);
+
+			/* now look for a plugin matching the id */
+			matches = gplugin_manager_find_plugins_with_version(
+				manager,
+				oid,
+				oop,
+				over);
+			g_free(oid);
+			g_free(oop);
+			g_free(over);
+
+			if(matches == NULL) {
+				continue;
+			}
+
+			/* prepend the first found match to our return value */
+			ret = g_slist_prepend(ret, g_object_ref(matches->data));
+			g_slist_free_full(matches, g_object_unref);
+
+			found = TRUE;
+
+			break;
+		}
+		g_strfreev(ors);
+
+		if(!found) {
+			g_set_error(
+				error,
+				GPLUGIN_DOMAIN,
+				0,
+				_("failed to find dependency %s for %s"),
+				dependencies[i],
+				gplugin_plugin_info_get_id(info));
+
+			g_slist_free_full(ret, g_object_unref);
+
+			return NULL;
+		}
+	}
+
+	return ret;
 }
 
 /**
  * gplugin_manager_load_plugin:
+ * @manager: The #GPluginManager instance.
  * @plugin: #GPluginPlugin instance.
  * @error: (out) (nullable): return location for a #GError or %NULL.
  *
